#include <stdio.h>
#include <stdlib.h>
#include "graphe_p.H"

#define E_INDICE_NOEUD 1
#define E_N 2
#define E_MEMOIRE 3

class arbre_p
{
	private:
	int n;
	int root;
	int *pt;
	int *poidt;
//	Sens des arcs : vrai s'ils s'loignent de la racine.
	char *senst;
	int *dt;
	int *st;

	public:
	arbre_p(int _n,int *_noeuds);
	arbre_p(int _n,int r,graphe_p *graph,arbre_p *arbre_ini);

	int taille();
	int racine();
	int p(int k);
	int poid(int k);
	char sens(int k);
	int d(int k);
	int s(int k);

	void entre(int ex,int ey,int *sx,int *sy,int *min);

	private:
	void copie(int a,int *pt,int *poidt,char *senst,int *dt,arbre_p *arbre_ini);
	char arete(int a,int b,graphe_p *graph);
	void cycle(int ex,int ey,int *am,char *cotex,int *min,int *join);
	void poid_cycle(int ex,int ey,int min,int join);
	int maj_s(int e1,int e2,int f1,int f2);
	void maj_p_poid_sens(int e1,int e2,int min,int se2,int f2);
	void maj_d(int e2,int dernier);
	void maj_arbre(int ex,int ey,int cotex,int min,int am);

	int arbre_p :: rech_dernier(int dsr,int noeud);
	
	public:
	int dernier(int sous_racine);
	
	private:
	void erreur(int i);
};
