#include <stdio.h>
#include "arbre_p.H"

#define E_N_TI 1
#define E_COMPATIBLE 2 


class trans_ini
{
	private:
	int n;
	graphe_p *graph;
	arbre_p *arbre;
	
	public:
	trans_ini(int _n,graphe_p *_graph,arbre_p *_arbre);
	
	arbre_p *donne_arbre();
	
	private:
	void affiche(long int *c);
	void ecrit(int a);
	void affiche_arbre();
	void cree_c(long int *c);
	char trouve_e(int *ex,int *ey,int *gain,long int *c);
	
	public:
	int cout_arbre();
	void resolution();
	
	private:
	void erreur(int k);
};
